var https = require("https");

function NodeFQL()
{
	/**
		TODO:	Use prototypes rather than internal this.* 
				Look into "template queries" [Branch from original obj]
				Unit test, general debugging, and generally refactor
	*/
	
	var appId = "";
	var appSecret = "";
	
	
	function Query(data)
	{
		var _data = data;

		this.toString = function()
		{
			if(_data["query"])
				return _data["query"];

			var temp = [
				"SELECT"
				, _data["fields"].join(", ")
				, "FROM"
				, _data["table"]
				, "WHERE"
				, _data["conds"].join(" ")
			].join(" ");

			return temp;
		}

		this.addCondition = function(data)
		{
			if(_data["query"])	
				return 0;

			var cond = [];

			if(data["join"])
				cond.push(data["join"]);
			
			if(data["query"] instanceof Query)
				data["query"] = ["(", data["query"].toString(), ")"].join("");

			cond = cond.concat([data["field"], data["compare"], data["query"]]);

			if(_data["conds"]) _data["conds"].push(cond.join(" "));
			else _data["conds"] = [cond.join(" ")];
		}

		this.send = function(token, callback)
		{
			execute(token, this.toString(), callback);
		}
	}

	function execute(token, query, callback)
	{
		if(!(callback instanceof Function)) 
			return 0;
		
		var path = "/method/fql.query?format=json";
		path += ("&access_token=" + token);
		path += ("&query=" + query);

		console.log(path);
		return 1;

		var body = "";
		https.get({ "host" : "api.facebook.com", "path" : path }, function(res)
		{
			res.on("data", function(chunk) { body += chunk; });
			res.on("end", function() { callback(JSON.parse(body)); });
		});
	}
	this.execute = execute;

	this.init = function(id, secret)
	{
		appId = id;
		appSecret = secret;
	}

	this.create = function(data)
	{
		if(!data["query"] || !(data["fields"] && data["table"]))
			return new Query(data);
		else
			return 0;
	}

	/**
		Async, parallel API requests. Will take in a token, 'N' queries, and a callback
	*/
	this.batch = function()
	{

	}
}

module.exports = new NodeFQL();

