var FQL = require("../lib/node-fql"); 
FQL.init("0", "0");

FQL.execute("tokenA", "SELECT name FROM user WHERE uid = me()", function(data) {});

var q1 = FQL.create({ "query" : "SELECT name FROM user WHERE uid = me()" });
q1.send("tokenB", function(data) {});

var q2 = FQL.create({ "table" : "friend", "fields" : ["uid2"] });
q2.addCondition({ "field" : "uid1", "compare" : "=", "query" : "me()" });

var q3 = FQL.create({ "table" : "user", "fields" : ["uid", "name", "pic_square"] });
q3.addCondition({ "field" : "uid", "compare" : "=", "query" : "me()" });
q3.addCondition({ "join" : "OR", "field" : "uid", "compare" : "IN", "query" : q2 });
q3.send("tokenC", function(data) {});
